state("higan")
{
	ushort fileSelect : 0x515525;
	byte linkState : 0x515658;
	short mapTile : 0x515414;
	byte itemValue : 0x5155DC;
	byte world : 0x515DA8;
	byte yPos : 0x5162C9;
	byte endTrigger : 0x51571C;
}

state("snes9x", "1.53")
{
	ushort fileSelect : 0x2EFBA4, 0x221;
	byte linkState : 0x2EFBA4, 0x354;
	short mapTile : 0x2EFBA4, 0x110;
	byte itemValue : 0x2EFBA4, 0x2D8;
	byte world : 0x2EFBA4, 0xAA4;
	byte yPos : 0x2EFBA4, 0xFC5;
	byte endTrigger : 0x2EFBA4, 0x418;
}

state("snes9x-x64", "1.53")
{
	ushort fileSelect : 0x405EC8, 0x221;
	byte linkState : 0x405EC8, 0x354;
	short mapTile : 0x405EC8, 0x110;
	byte itemValue : 0x405EC8, 0x2D8;
	byte world : 0x405EC8, 0xAA4;
	byte yPos : 0x405EC8, 0xFC5;
	byte endTrigger : 0x405EC8, 0x418;
}

state("snes9x", "1.54.1")
{
	ushort fileSelect : 0x3410D4, 0x221;
	byte linkState : 0x3410D4, 0x354;
	short mapTile : 0x3410D4, 0x110;
	byte itemValue : 0x3410D4, 0x2D8;
	byte world : 0x3410D4, 0xAA4;
	byte yPos : 0x3410D4, 0xFC5;
	byte endTrigger : 0x3410D4, 0x418;
}

state("snes9x-x64", "1.54.1")
{
	ushort fileSelect : 0x4DAF18, 0x221;
	byte linkState : 0x4DAF18, 0x354;
	short mapTile : 0x4DAF18, 0x110;
	byte itemValue : 0x4DAF18, 0x2D8;
	byte world : 0x4DAF18, 0xAA4;
	byte yPos : 0x4DAF18, 0xFC5;
	byte endTrigger : 0x4DAF18, 0x418;
}

startup
{
	settings.Add("secret", true, "Enter the secret entrance");
	settings.Add("castle", true, "Enter the castle");
	settings.Add("damage", true, "Enter the room and get hit");
	settings.Add("end", true, "Enter Triforce Room");
}

init
{
	//snes9x
	//1.53 x86: 5914624
	//1.53 x64: 6909952
	//1.54.1 x86: 6447104
	//1.54.1 x64: 7946240

	var memSize = modules.First().ModuleMemorySize;
	if (memSize == 6447104 || memSize == 7946240)
		version = "1.54.1";

  	vars.lastItem = 0;
}

update
{
	if (current.itemValue != old.itemValue && current.itemValue != 0)
		vars.lastItem = current.itemValue;
	print("Map tile: " + current.mapTile);
}

start
{
	return old.fileSelect == 0 && current.fileSelect == 0xFFFF;
}

reset
{
	return old.fileSelect == 0xFFFF && current.fileSelect != 0xFFFF;
}

split
{
	var secret = settings["secret"] && old.mapTile == 0x30c && current.mapTile == 0xff;
	var castle = settings["castle"] && old.mapTile == 0xff && current.mapTile == 0x123;
	var damage = settings["damage"] && old.mapTile == 0x123 && current.mapTile == 0x120;
	var end = settings["end"] && old.endTrigger == 0 && current.endTrigger == 0x01 && current.mapTile == 0;

	return secret || castle || damage || end;
}
